//----------------------------------------------------------------------------------
//aviutlvOC C^Ȓጸ(LPF)
//
//----------------------------------------------------------------------------------
#include <windows.h>
#include <mmintrin.h>

#include "filter.h"

// ֐
int lpf_v_3(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_5(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_7(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_9(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_11(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_3_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_5_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_7_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_9_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_11_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int (*lpf_v[])(PIXEL_YC*, PIXEL_YC*, int, int, int, int, int)
     = { lpf_v_3,     lpf_v_5,     lpf_v_7,     lpf_v_9,     lpf_v_11,
         lpf_v_3_mmx, lpf_v_5_mmx, lpf_v_7_mmx, lpf_v_9_mmx, lpf_v_11_mmx };


//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 3 //gbNo[̐
TCHAR *track_name[] = {"tap", "", "" }; //gbNo[̖O
int   track_default[] = { 0, 0, 0 }; //gbNo[̏l
int   track_s[] = { 0, 0 , 0 }; //gbNo[̉l
int   track_e[] = { 4, 64, 64 }; //gbNo[̏l
enum  { T_TAP, T_TOP, T_BTM };

#define CHECK_N 1 //`FbN{bNX̐
TCHAR *check_name[] = { "MMX" }; //`FbN{bNX̖O
int    check_default[] = { 1 }; //`FbN{bNX̏l (l01)
enum { C_MMX };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, //| FILTER_FLAG_WINDOW_SIZE, //tB^̃tO
  0,0,                        //ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
  "C^Ȓጸ", //tB^̖O
  TRACK_N,                    //gbNo[̐ (0Ȃ疼OlNULLł悢)
  track_name,                 //gbNo[̖OSւ̃|C^
  track_default,              //gbNo[̏lSւ̃|C^
  track_s,track_e,            //gbNo[̐l̉ (NULLȂS0`256)
  CHECK_N,                    //`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
  check_name,                 //`FbN{bNX̖OSւ̃|C^
  check_default,              //`FbN{bNX̏lSւ̃|C^
  func_proc,                  //tB^֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                  //JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,NULL,                  //VXeŎg܂̂ŎgpȂł
  NULL,                       //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  0,                       //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  "lpf_decomb by N099, ver1.0",  //  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
  NULL,                       //Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)

};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
  int fnum;

  fnum = fp->track[T_TAP];
  fnum += fp->check[C_MMX] * (track_e[T_TAP] + 1);
  if(0 == lpf_v[fnum]( fpip->ycp_temp, fpip->ycp_edit,
                       fpip->h,
                       fp->track[T_TOP], fp->track[T_BTM],
                       fpip->max_w, fpip->w ))
    {
      PIXEL_YC *ycp;
      
      ycp = fpip->ycp_temp;
      fpip->ycp_temp = fpip->ycp_edit;
      fpip->ycp_edit = ycp;
      return TRUE;
    }

  return FALSE;
}

// 3tap LPF
// ht Jn, hbAI荂
int lpf_v_3(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l2;
  short *src0, *src1, *src2, *dst0;
  short tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l0 = i>0 ? i-1 : 0;
    l2 = i<(h-1) ? i+1 : h-1;

    dst0 = (short *)(dst + i * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + i * max_w);
    src2 = (short *)(src + l2 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src1, max_w * sizeof(PIXEL_YC));
      continue;
    }
      
    for(j=0; j<w; ++j){
      tmp = *src0 + *src2;
      tmp = *src1 + (tmp >> 1);
      *dst0 = tmp >> 1;

      src0++;
      src1++;
      src2++;
      dst0++;
    }
  }

  return 0;
}

// 5tap LPF
int lpf_v_5(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l3,l4;
  short *src0, *src1, *src2, *src3, *src4, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l1 = i>0 ? i-1 : 0;
    l3 = i<(h-1) ? i+1 : h-1;
    l0 = (i-1)>0 ? i-2 : l1;
    l4 = i<(h-2) ? i+2 : l3;
    
    dst0 = (short *)(dst + i * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + i  * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src2, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *src4;
      tmp = (*src1 + *src3) * 1021 - (tmp * 226);
      *dst0 = (tmp + *src2 * 2506) >> 12;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      dst0++;
    }
  }

  return 0;
}

// 7tap LPF
int lpf_v_7(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l2,l4,l5,l6;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l2 = i>0 ? i-1 : 0;
    l4 = i<(h-1) ? i+1 : h-1;
    l1 = (i-1)>0 ? i-2 : l2;
    l5 = i<(h-2) ? i+2 : l4;
    l0 = (i-2)>0 ? i-3 : l1;
    l6 = i<(h-3) ? i+3 : l5;

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + i  * max_w);
    src4 = (short *)(src + l4 * max_w);
    src5 = (short *)(src + l5 * max_w);
    src6 = (short *)(src + l6 * max_w);
    
    if(i<ht || i>hb){
      memcpy(dst0, src3, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *src6;
      tmp = (*src1 + *src5) * 456 - (tmp * 79);
      tmp = (*src2 + *src4) * 940 - tmp;
      *dst0 = (tmp + *src3 * 2970) >> 12;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      dst0++;
    }
  }

  return 0;
}

// 9tap LPF
int lpf_v_9(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
   int i,j;
  int l0,l1,l2,l3,l5,l6,l7,l8;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *src7, *src8, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l3 = i>0 ? i-1 : 0;
    l5 = i<(h-1) ? i+1 : h-1;
    l2 = (i-1)>0 ? i-2 : l3;
    l6 = i<(h-2) ? i+2 : l5;
    l1 = (i-2)>0 ? i-3 : l2;
    l7 = i<(h-3) ? i+3 : l6;
    l0 = (i-3)>0 ? i-4 : l1;
    l8 = i<(h-4) ? i+4 : l7;

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + i  * max_w);
    src5 = (short *)(src + l5 * max_w);
    src6 = (short *)(src + l6 * max_w);
    src7 = (short *)(src + l7 * max_w);
    src8 = (short *)(src + l8 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src4, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *src8;
      tmp = (*src1 + *src7) * 858 - (tmp * 116);
      tmp = (*src2 + *src6) * 2075 - tmp;
      tmp = (*src3 + *src5) * 3222 - tmp;
      *dst0 = (tmp + *src4 * 12606) >> 14;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;      
      dst0++;
    }
  }

  return 0;
}

// 11tap LPF
int lpf_v_11(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
   int i,j;
  int l0,l1,l2,l3,l4,l6,l7,l8,l9,la;
  short *src0, *src1, *src2, *src3, *src4, *src5;
  short *src6, *src7, *src8, *src9, *srca, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l4 = i>0 ? i-1 : 0;
    l6 = i<(h-1) ? i+1 : h-1;
    l3 = (i-1)>0 ? i-2 : l4;
    l7 = i<(h-2) ? i+2 : l6;
    l2 = (i-2)>0 ? i-3 : l3;
    l8 = i<(h-3) ? i+3 : l7;
    l1 = (i-3)>0 ? i-4 : l2;
    l9 = i<(h-4) ? i+4 : l8;
    l0 = (i-4)>0 ? i-5 : l1;
    la = i<(h-5) ? i+5 : l9;    

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);
    src5 = (short *)(src + i  * max_w);
    src6 = (short *)(src + l6 * max_w);
    src7 = (short *)(src + l7 * max_w);
    src8 = (short *)(src + l8 * max_w);
    src9 = (short *)(src + l9 * max_w);
    srca = (short *)(src + la * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *srca;
      tmp = (*src1 + *src9) * 462 - (tmp * 53);
      tmp = (*src2 + *src8) * 1209 - tmp;
      tmp = (*src3 + *src7) * 2092 - tmp;
      tmp = (*src4 + *src6) * 2807 - tmp;
      *dst0 = (tmp + *src5 * 13354) >> 14;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;     
      dst0++;
    }
  }

  return 0;
}

// 3tap LPF w/ MMX
// ht Jn, hbAI荂
int lpf_v_3_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l2;
  short *src0, *src1, *src2, *dst0;
  short tmp;
  __m64 s0, s1, s2, t0, d0;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l0 = i>0 ? i-1 : 0;
    l2 = i<(h-1) ? i+1 : h-1;

    dst0 = (short *)(dst + i * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + i * max_w);
    src2 = (short *)(src + l2 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src1, max_w * sizeof(PIXEL_YC));
      continue;
    }
      
    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      s1 = *(__m64 *)src1;
      s2 = *(__m64 *)src2;
      t0 = _mm_adds_pi16(s0, s2);
      t0 = _mm_srai_pi16(t0, 1);
      d0 = _mm_adds_pi16(s1, t0);
      *(__m64 *)dst0 = _mm_srai_pi16(d0, 1);

      src0 += 4;
      src1 += 4;
      src2 += 4;
      dst0 += 4;
    }
    //c
    for( ; j>0; --j){
      tmp = *src0 + *src2;
      tmp = *src1 + (tmp >> 1);
      *dst0 = tmp >> 1;

      src0++;
      src1++;
      src2++;
      dst0++;
    }
  }

  _mm_empty();
  
  return 0;
}

// 5tap LPF w/ MMX
int lpf_v_5_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l3,l4;
  short *src0, *src1, *src2, *src3, *src4, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, c0, c1;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;
  c0 = _mm_set_pi16(-226, 1021, -226, 1021);
  c1 = _mm_set_pi16(2506, 0, 2506, 0);

  for(i=0; i<h; i++){
    l1 = i>0 ? i-1 : 0;
    l3 = i<(h-1) ? i+1 : h-1;
    l0 = (i-1)>0 ? i-2 : l1;
    l4 = i<(h-2) ? i+2 : l3;
    
    dst0 = (short *)(dst + i * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + i  * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src2, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      s1 = *(__m64 *)src1;
      s2 = *(__m64 *)src2;
      s3 = *(__m64 *)src3;
      s4 = *(__m64 *)src4;

      s0 = _mm_adds_pi16(s0, s4);
      s1 = _mm_adds_pi16(s1, s3);

      s4 = _mm_unpackhi_pi16(s1, s0);
      s3 = _mm_unpacklo_pi16(s1, s0);

      s4 = _mm_madd_pi16(s4, c0);
      s3 = _mm_madd_pi16(s3, c0);

      s0 = _mm_unpackhi_pi16(s0, s2);
      s1 = _mm_unpacklo_pi16(s1, s2);

      s0 = _mm_madd_pi16(s0, c1);
      s1 = _mm_madd_pi16(s1, c1);

      s0 = _mm_add_pi32(s0, s4);
      s1 = _mm_add_pi32(s1, s3);

      s0 = _mm_srai_pi32(s0, 12);
      s1 = _mm_srai_pi32(s1, 12);

      s2 = _mm_packs_pi32(s1, s0);
      *(__m64 *)dst0 = s2;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      dst0 += 4;
    }
    //̂
    for( ; j>0; --j){
      tmp = *src0 + *src4;
      tmp = (*src1 + *src3) * 1021 - (tmp * 226);
      *dst0 = (tmp + *src2 * 2506) >> 12;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      dst0++;
    }
  }

  _mm_empty();

  return 0;
}

// 7tap LPF w/ MMX
int lpf_v_7_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l2,l4,l5,l6;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, c0, c1;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;
  c0 = _mm_set_pi16(79, -456, 79, -456);
  c1 = _mm_set_pi16(2970, 940, 2970, 940);
  
  for(i=0; i<h; i++){
    l2 = i>0 ? i-1 : 0;
    l4 = i<(h-1) ? i+1 : h-1;
    l1 = (i-1)>0 ? i-2 : l2;
    l5 = i<(h-2) ? i+2 : l4;
    l0 = (i-2)>0 ? i-3 : l1;
    l6 = i<(h-3) ? i+3 : l5;

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + i  * max_w);
    src4 = (short *)(src + l4 * max_w);
    src5 = (short *)(src + l5 * max_w);
    src6 = (short *)(src + l6 * max_w);
    
    if(i<ht || i>hb){
      memcpy(dst0, src3, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      s1 = *(__m64 *)src1;
      s2 = *(__m64 *)src2;
      s3 = *(__m64 *)src3;
      s4 = *(__m64 *)src4;
      s5 = *(__m64 *)src5;
      s6 = *(__m64 *)src6;
      
      s0 = _mm_adds_pi16(s0, s6);
      s1 = _mm_adds_pi16(s1, s5);
      s2 = _mm_adds_pi16(s2, s4);

      s6 = _mm_unpackhi_pi16(s1, s0);
      s5 = _mm_unpacklo_pi16(s1, s0);
      s4 = _mm_unpackhi_pi16(s2, s3);
      s3 = _mm_unpacklo_pi16(s2, s3);
      
      s6 = _mm_madd_pi16(s6, c0);
      s5 = _mm_madd_pi16(s5, c0);
      s4 = _mm_madd_pi16(s4, c1);
      s3 = _mm_madd_pi16(s3, c1);

      s6 = _mm_add_pi32(s6, s4);
      s5 = _mm_add_pi32(s5, s3);

      s6 = _mm_srai_pi32(s6, 12);
      s5 = _mm_srai_pi32(s5, 12);

      s5 = _mm_packs_pi32(s5, s6);
      *(__m64 *)dst0 = s5;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      dst0 += 4;
    }
    //c
    for( ; j>0; --j){
      tmp = *src0 + *src6;
      tmp = (*src1 + *src5) * 456 - (tmp * 79);
      tmp = (*src2 + *src4) * 940 - tmp;
      *dst0 = (tmp + *src3 * 2970) >> 12;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      dst0++;
    }
  }

  _mm_empty();

  return 0;
}

// 9tap LPF w/ MMX
int lpf_v_9_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
   int i,j;
  int l0,l1,l2,l3,l5,l6,l7,l8;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *src7, *src8, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, s7, s8, c0, c1, c2;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;
  c0 = _mm_set_pi16(-116, 858, -116, 858);
  c1 = _mm_set_pi16(-2075, 3222, -2075, 3222);
  c2 = _mm_set_pi16(12606, 0, 12606, 0);
  
  for(i=0; i<h; i++){
    l3 = i>0 ? i-1 : 0;
    l5 = i<(h-1) ? i+1 : h-1;
    l2 = (i-1)>0 ? i-2 : l3;
    l6 = i<(h-2) ? i+2 : l5;
    l1 = (i-2)>0 ? i-3 : l2;
    l7 = i<(h-3) ? i+3 : l6;
    l0 = (i-3)>0 ? i-4 : l1;
    l8 = i<(h-4) ? i+4 : l7;

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + i  * max_w);
    src5 = (short *)(src + l5 * max_w);
    src6 = (short *)(src + l6 * max_w);
    src7 = (short *)(src + l7 * max_w);
    src8 = (short *)(src + l8 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src4, max_w * sizeof(PIXEL_YC));
      continue;
    }

    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      s8 = *(__m64 *)src8;

      s0 = _mm_adds_pi16(s0, s8);

      s1 = *(__m64 *)src1;
      s7 = *(__m64 *)src7;
      
      s1 = _mm_adds_pi16(s1, s7);

      s8 = _mm_unpackhi_pi16(s1, s0);
      s1 = _mm_unpacklo_pi16(s1, s0);

      //
      s2 = *(__m64 *)src2;
      s6 = *(__m64 *)src6;

      s2 = _mm_adds_pi16(s2, s6);

      s3 = *(__m64 *)src3;
      s5 = *(__m64 *)src5;
      
      s3 = _mm_adds_pi16(s3, s5);

      s7 = _mm_unpackhi_pi16(s3, s2);
      s3 = _mm_unpacklo_pi16(s3, s2);

      //
      s8 = _mm_madd_pi16(s8, c0);
      s7 = _mm_madd_pi16(s7, c1);
      s8 = _mm_add_pi32(s8, s7);
      
      s1 = _mm_madd_pi16(s1, c0);
      s3 = _mm_madd_pi16(s3, c1);
      s3 = _mm_add_pi32(s3, s1);
      
      s4 = *(__m64 *)src4;

      s0 = _mm_unpackhi_pi16(s0, s4);
      s2 = _mm_unpacklo_pi16(s2, s4);

      s0 = _mm_madd_pi16(s0, c2);
      s2 = _mm_madd_pi16(s2, c2);

      s0 = _mm_add_pi32(s0, s8);
      s2 = _mm_add_pi32(s2, s3);

      s0 = _mm_srai_pi32(s0, 14);
      s2 = _mm_srai_pi32(s2, 14);

      s2 = _mm_packs_pi32(s2, s0);
      *(__m64 *)dst0 = s2;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      src7 += 4;
      src8 += 4;     
      dst0 += 4;
    }
    //̂
    for( ; j>0; --j){
      tmp = *src0 + *src8;
      tmp = (*src1 + *src7) * 858 - (tmp * 116);
      tmp = (*src2 + *src6) * 2075 - tmp;
      tmp = (*src3 + *src5) * 3222 - tmp;
      *dst0 = (tmp + *src4 * 12606) >> 14;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;      
      dst0++;
    }
  }

  _mm_empty();

  return 0;
}

// 11tap LPF w/ MMX
int lpf_v_11_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
   int i,j;
  int l0,l1,l2,l3,l4,l6,l7,l8,l9,la;
  short *src0, *src1, *src2, *src3, *src4, *src5;
  short *src6, *src7, *src8, *src9, *srca, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, sa, c0, c1, c2;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;
  c0 = _mm_set_pi16(53, -462, 53, -462);
  c1 = _mm_set_pi16(-2092, 1209, -2092, 1209);
  c2 = _mm_set_pi16(13354, 2807, 13354, 2807);
  
  for(i=0; i<h; i++){
    l4 = i>0 ? i-1 : 0;
    l6 = i<(h-1) ? i+1 : h-1;
    l3 = (i-1)>0 ? i-2 : l4;
    l7 = i<(h-2) ? i+2 : l6;
    l2 = (i-2)>0 ? i-3 : l3;
    l8 = i<(h-3) ? i+3 : l7;
    l1 = (i-3)>0 ? i-4 : l2;
    l9 = i<(h-4) ? i+4 : l8;
    l0 = (i-4)>0 ? i-5 : l1;
    la = i<(h-5) ? i+5 : l9;    

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);
    src5 = (short *)(src + i  * max_w);
    src6 = (short *)(src + l6 * max_w);
    src7 = (short *)(src + l7 * max_w);
    src8 = (short *)(src + l8 * max_w);
    src9 = (short *)(src + l9 * max_w);
    srca = (short *)(src + la * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=w; j>3; j-=4){
      //
      s0 = *(__m64 *)src0;
      sa = *(__m64 *)srca;
      s0 = _mm_adds_pi16(s0, sa);
      
      s1 = *(__m64 *)src1;
      s9 = *(__m64 *)src9;
      s1 = _mm_adds_pi16(s1, s9);

      s9 = _mm_unpackhi_pi16(s1, s0);
      s1 = _mm_unpacklo_pi16(s1, s0);

      s9 = _mm_madd_pi16(s9, c0);
      s1 = _mm_madd_pi16(s1, c0);

      //
      s2 = *(__m64 *)src2;
      s8 = *(__m64 *)src8;
      s2 = _mm_adds_pi16(s2, s8);

      s3 = *(__m64 *)src3;
      s7 = *(__m64 *)src7;
      s3 = _mm_adds_pi16(s3, s7);
      
      s8 = _mm_unpackhi_pi16(s2, s3);
      s2 = _mm_unpacklo_pi16(s2, s3);

      s8 = _mm_madd_pi16(s8, c1);
      s2 = _mm_madd_pi16(s2, c1);

      s9 = _mm_add_pi32(s9, s8);
      s1 = _mm_add_pi32(s1, s2);

      //
      s4 = *(__m64 *)src4;
      s6 = *(__m64 *)src6;
      s4 = _mm_adds_pi16(s4, s6);
      
      s5 = *(__m64 *)src5;
      s6 = _mm_unpackhi_pi16(s4, s5);
      s4 = _mm_unpacklo_pi16(s4, s5);
      
      s6 = _mm_madd_pi16(s6, c2);
      s4 = _mm_madd_pi16(s4, c2);

      s9 = _mm_add_pi32(s9, s6);
      s1 = _mm_add_pi32(s1, s4);

      s9 = _mm_srai_pi32(s9, 14);
      s1 = _mm_srai_pi32(s1, 14);

      s1 = _mm_packs_pi32(s1, s9);
      *(__m64 *)dst0 = s1;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      src7 += 4;
      src8 += 4;
      src9 += 4;
      srca += 4;
      dst0 += 4;
    }
    //̂
    for( ; j>0; --j){
      tmp = *src0 + *srca;
      tmp = (*src1 + *src9) * 462 - (tmp * 53);
      tmp = (*src2 + *src8) * 1209 - tmp;
      tmp = (*src3 + *src7) * 2092 - tmp;
      tmp = (*src4 + *src6) * 2807 - tmp;
      *dst0 = (tmp + *src5 * 13354) >> 14;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;     
      dst0++;
    }
  }

  _mm_empty();

  return 0;
}

